; BareNumbersOS v.0.4 - GPL3 - Apr 2013
; Hello World Assembly Test Program
;
; fasm bn_hello.asm hello.bin

USE64					; Flat 64-bit
ORG 0x0000000000600000			; Memory location for programs
jmp start				; Skip the table

	include 'bn_syscalls.inc'	; Table with syscalls addresses

start:					; Start of program label
	call init_syscalls_table	; Fill the table with syscalls addresses

	mov rsi, hello_message		; Load RSI with memory address of string
	call [sys_print_string]		; Print the string that RSI points to
	call [sys_print_newline]	; Print an empty line

ret					; Return to OS

; Data
	hello_message: db 'Hello, world!', 0

