; BareNumbersOS v.0.4 - GPL3 - Apr 2013
; Hello World Assembly Test Program
;
; fasm bn_hello-ui.asm hello-ui.bin

USE64					; Flat 64-bit
ORG 0x0000000000600000			; Memory location for programs
jmp start				; Skip the table and controls

	include 'bn_syscalls.inc'	; Table with syscalls addresses
	include 'bn_controls.inc'	; Tiles and Controls

start:					; Start of program label
	call init_syscalls_table	; Fill the table with syscalls addresses

	call start_UI			; Initialize User Interface manager and start

ret					; Return to OS

alabel1function:
	push rax
	push rdx

	mov rax, ctrl_a1b		; alabel1
	mov rdx, qword[rax+TAG] 	;
	cmp rdx, 0
	je .end				; no actived

	call [sys_exit_UI]		; Exit from UI manager

.end:
	pop rdx
	pop rax
	ret

